//Actions
import {
    INIT_PAYMENTS_PURCHASES_SUPPLIER,
    FILTER_PAYMENTS_PURCHASES_SUPPLIER,
    SELECT_PAYMENTS_PURCHASES_SUPPLIER

} from '@/constants/actionTypes'
// Mutations
import {
    SET_SUPPLIER,
    SET_LOADING_SUPPLIER ,
    SET_FILTER_PAYMENTS_PURCHASES_SUPPLIER,
    SET_SELECTED_PAYMENTS_PURCHASES_SUPPLIER
}from '@/constants/mutationTypes'

const initialState = {
    supplier: [],
    filterSupplier:[],
    loadingSupplier: false,
    selectedSupplier: null
}

const state = {
    supplier: initialState.supplier,
    loadingSupplier: initialState.loadingSupplier,
    filterSupplier: initialState.filterSupplier,
    selectedSupplier: initialState.selectedSupplier
}

const getters = {
    /**
     * [supplier description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    supplier ( state ) {
        return state.supplier
    },
    /**
     * [loadingSupplier description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    loadingSupplier ( state ) {
        return !state.loadingSupplier
    },
    /**
     * [selectedSupplier description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    selectedSupplier ( state ) {
        return state.selectedSupplier
    },
    /**
     * [supplierVisible description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    supplierVisible ( state ) {
        return state.filterSupplier.length === 0 ? state.supplier : state.filterSupplier
    }
}

const mutations = {
    /**
     * [supplier description]
     * @type {[type]}
     */
    [SET_SUPPLIER] (state, paylod) {
        state.supplier = paylod
    },
    /**
     * [loadingSupplier description]
     * @type {[type]}
     */
    [SET_LOADING_SUPPLIER] (state, paylod) {
        state.loadingSupplier = paylod
    },
    /**
     * [filterSupplier description]
     * @type {[type]}
     */
    [SET_FILTER_PAYMENTS_PURCHASES_SUPPLIER] (state, paylod) {
        state.filterSupplier = paylod
    },
    /**
     * [selectedSupplier description]
     * @type {[type]}
     */
    [SET_SELECTED_PAYMENTS_PURCHASES_SUPPLIER] ( state, paylod ) {
        state.selectedSupplier = paylod
    }
}

const actions = {
    /**
     * [INIT_PAYMENTS_PURCHASES_SUPPLIER]
     */
    [INIT_PAYMENTS_PURCHASES_SUPPLIER] ({ commit },paylod) {
        commit(SET_SUPPLIER, paylod)
        commit(SET_LOADING_SUPPLIER, paylod)
    },
    /**
     * [ FILTER_PAYMENTS_PURCHASES_SUPPLIER ]
     */
    [FILTER_PAYMENTS_PURCHASES_SUPPLIER] ({ commit }, paylod) {
        commit(SET_FILTER_PAYMENTS_PURCHASES_SUPPLIER, paylod)
    },
    /**
     * [SELECT_PAYMENTS_PURCHASES_SUPPLIER]
     */
    [SELECT_PAYMENTS_PURCHASES_SUPPLIER] ({ commit }, paylod) {
        commit(SET_SELECTED_PAYMENTS_PURCHASES_SUPPLIER, paylod)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
